package fr.username404.snowygui.gui.feature

import com.mojang.blaze3d.vertex.PoseStack
import fr.username404.snowygui.EventSnowy.Companion.useKey
import fr.username404.snowygui.argsLambda
import fr.username404.snowygui.gui.Renderable

sealed class ButtonImplWithHud: ButtonImpl() {
    protected abstract val hudRenderLambda: Renderable
    private val generatedLambda: argsLambda = { hudRenderLambda.render(it.first() as PoseStack?) }
    final override fun execAction() {
        useKey("HudRender").run {
            if (toggled) add(generatedLambda)
            else remove(generatedLambda)
        }
    }
}